=== debian/changelog ===
vulkan (1.0.61.1+dfsg1-1ubuntu1~16.04.1) xenial; urgency=medium

  * Backport to xenial. (LP: #1716203)

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 03 Jan 2018 11:07:38 +0200

vulkan (1.0.61.1+dfsg1-1ubuntu1) artful; urgency=medium

  * Merge from Debian.
  * Refresh & port Mir patches.

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 21 Sep 2017 15:47:53 +0300

vulkan (1.0.61.1+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * patches: Dropped install-vk-layer-dispatch-table-h.diff which is
    upstream, refresh use-mxgot-for-mips64.patch.

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 21 Sep 2017 15:28:57 +0300

vulkan (1.0.54.0+dfsg1-1ubuntu1) artful; urgency=medium

  * Merge from Debian.
  * patches: Refreshed.

 -- Timo Aaltonen <tjaalton@debian.org>  Mon, 31 Jul 2017 16:57:18 +0300

vulkan (1.0.54.0+dfsg1-1) unstable; urgency=medium

  * New upstream release.

 -- Timo Aaltonen <tjaalton@debian.org>  Mon, 24 Jul 2017 12:38:14 +0300

vulkan (1.0.51.0+dfsg1-1ubuntu1) artful; urgency=medium

  * Merge from debian, remaining changes:
    - enable Mir support
    - port demos to Mir
  * demos-mir.diff: Fix smoke demo, check for libvulkan.so.1 instead of
    .so.

 -- Timo Aaltonen <tjaalton@debian.org>  Mon, 03 Jul 2017 17:39:17 +0300

vulkan (1.0.51.0+dfsg1-1) unstable; urgency=medium

  * New upstream release.
    - smoke-check-for-installed-so.diff: Dropped, upstream.
  * install-vk-layer-dispatch-table-h.diff: Put
    vk_layer_dispatch_table.h in include/vulkan. (LP: #1692244)
  * Rename vulkan-smoke to vulkan-smoketest.
  * rules: Fix glslang build.
  * copyright: Local copy of spirv.hpp got dropped, so drop it from
    copyright too.

 -- Timo Aaltonen <tjaalton@debian.org>  Mon, 03 Jul 2017 12:26:58 +0300

vulkan (1.0.46.0+dfsg3-1) experimental; urgency=medium

  * rules: Fix glslang/spir-v build to always run make.
  * get-external.sh, rules: Fix the order of spirv-tools/-headers, and
    rebuild the tarball. Thanks, Philipp Zabel!

 -- Timo Aaltonen <tjaalton@debian.org>  Sat, 20 May 2017 00:11:43 +0300

vulkan (1.0.46.0+dfsg2-1ubuntu1) artful; urgency=medium

  * Merge from Debian, remaining changes:
    - enable Mir support
  * demos-mir.diff: Port cube, smoke to Mir.

 -- Timo Aaltonen <tjaalton@debian.org>  Fri, 12 May 2017 19:38:46 +0300

vulkan (1.0.46.0+dfsg2-1) experimental; urgency=medium

  * Build libVkLayer.
    - debian/SPIRV/spirv.hpp: Dropped
    - debian/get-external.sh: Add a script to update glslang and SPIR-V
    - rules: Modify gentarball target
    - rules: Modify to build glslang & spirv first
    - libvulkan-dev.install, dirs, rules: Install json files, provide
      empty systemwide dirs
  * Install smoke demo.
    - demos-dont-build-tri-or-cube-or-smoke.diff ->
      demos-dont-build-cube.diff: Renamed and updated
    - smoke-check-for-installed-so.diff: Check for libvulkan.so.1 instead
      of .so
  * rules: Support parallel builds.
  * Add README.source and a reminder to get-external.sh to run git add.

 -- Timo Aaltonen <tjaalton@debian.org>  Fri, 12 May 2017 18:57:44 +0300

vulkan (1.0.46.0+dfsg1-1) experimental; urgency=medium

  * New upstream release.
  * trim-build.diff, disable-mir.diff, rules: Use clang build options
    instead of patching CMakeFile.txt.
  * rules: Set build type to 'Release'.
  * patches: Refreshed.
  * dev.install: Add pkgconfig file.

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 09 May 2017 14:21:14 +0300
